# SPDX-License-Identifier: Apache-2.0
#
# The OpenSearch Contributors require contributions made to
# this file be licensed under the Apache-2.0 license or a
# compatible open source license.
#
# Modifications Copyright OpenSearch Contributors. See
# GitHub history for details.
#
#  Licensed to Elasticsearch B.V. under one or more contributor
#  license agreements. See the NOTICE file distributed with
#  this work for additional information regarding copyright
#  ownership. Elasticsearch B.V. licenses this file to you under
#  the Apache License, Version 2.0 (the "License"); you may
#  not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
# 	http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing,
#  software distributed under the License is distributed on an
#  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
#  KIND, either express or implied.  See the License for the
#  specific language governing permissions and limitations
#  under the License.

from .utils import DslBase

class AnalysisBase(object): ...
class CustomAnalysis(object): ...
class CustomAnalysisDefinition(CustomAnalysis): ...
class BuiltinAnalysis(object): ...
class Analyzer(AnalysisBase, DslBase): ...
class BuiltinAnalyzer(BuiltinAnalysis, Analyzer): ...
class CustomAnalyzer(CustomAnalysisDefinition, Analyzer): ...
class Normalizer(AnalysisBase, DslBase): ...
class BuiltinNormalizer(BuiltinAnalysis, Normalizer): ...
class CustomNormalizer(CustomAnalysisDefinition, Normalizer): ...
class Tokenizer(AnalysisBase, DslBase): ...
class BuiltinTokenizer(BuiltinAnalysis, Tokenizer): ...
class CustomTokenizer(CustomAnalysis, Tokenizer): ...
class TokenFilter(AnalysisBase, DslBase): ...
class BuiltinTokenFilter(BuiltinAnalysis, TokenFilter): ...
class CustomTokenFilter(CustomAnalysis, TokenFilter): ...
class MultiplexerTokenFilter(CustomTokenFilter): ...
class ConditionalTokenFilter(CustomTokenFilter): ...
class CharFilter(AnalysisBase, DslBase): ...
class BuiltinCharFilter(BuiltinAnalysis, CharFilter): ...
class CustomCharFilter(CustomAnalysis, CharFilter): ...
